!MNH_LIC Copyright 1994-2023 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
MODULE MODI_ICE4_TENDENCIES
INTERFACE
SUBROUTINE ICE4_TENDENCIES(KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, &
                          &KRR, ODSOFT, PCOMPUTE, &
                          &OWARM, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, &
                          &HSUBG_AUCV_RC, HSUBG_AUCV_RI, HSUBG_PR_PDF, &
                          &PEXN, PRHODREF, PLVFACT, PLSFACT, K1, K2, K3, &
                          &PPRES, PCF, PSIGMA_RC, &
                          &PCIT, &
                          &PT, PTHT, &
                          &PRVT, PRCT, PRRT, PRIT, PRST, PRGT, PRHT, &
                          &PRVHENI_MR, PRRHONG_MR, PRIMLTC_MR, PRSRIMCG_MR, &
                          &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
                          &PRCAUTR, PRCACCR, PRREVAV, &
                          &PRCRIMSS, PRCRIMSG, PRSRIMCG, PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, PRCMLTSR, &
                          &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                          &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                          &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                          &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                          &PRCBERI, &
                          &PRS_TEND, PRG_TEND, PRH_TEND, PSSI, &
                          &PA_TH, PA_RV, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, &
                          &PB_TH, PB_RV, PB_RC, PB_RR, PB_RI, PB_RS, PB_RG, PB_RH, &
                          &PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC, &
                          &PHLI_HCF, PHLI_LCF, PHLI_HRI, PHLI_LRI, PRAINFR)
IMPLICIT NONE
INTEGER,                  INTENT(IN)    :: KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL
INTEGER,                  INTENT(IN)    :: KRR
LOGICAL,                  INTENT(IN)    :: ODSOFT
REAL, DIMENSION(:),       INTENT(IN)    :: PCOMPUTE
LOGICAL,                  INTENT(IN)    :: OWARM
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_RC_RR_ACCR
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_RR_EVAP
CHARACTER(len=4),         INTENT(IN)    :: HSUBG_AUCV_RC
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_AUCV_RI
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_PR_PDF ! pdf for subgrid precipitation
REAL, DIMENSION(:),       INTENT(IN)    :: PEXN
REAL, DIMENSION(:),       INTENT(IN)    :: PRHODREF
REAL, DIMENSION(:),       INTENT(IN)    :: PLVFACT
REAL, DIMENSION(:),       INTENT(IN)    :: PLSFACT
INTEGER, DIMENSION(:),    INTENT(IN)    :: K1
INTEGER, DIMENSION(:),    INTENT(IN)    :: K2
INTEGER, DIMENSION(:),    INTENT(IN)    :: K3
REAL, DIMENSION(:),       INTENT(IN)    :: PPRES
REAL, DIMENSION(:),       INTENT(IN)    :: PCF
REAL, DIMENSION(:),       INTENT(INOUT) :: PCIT
REAL, DIMENSION(:),       INTENT(IN)    :: PT
REAL, DIMENSION(:),       INTENT(IN)    :: PTHT
REAL, DIMENSION(:),       INTENT(IN)    :: PRVT
REAL, DIMENSION(:),       INTENT(IN)    :: PRCT
REAL, DIMENSION(:),       INTENT(IN)    :: PRRT
REAL, DIMENSION(:),       INTENT(IN)    :: PRIT
REAL, DIMENSION(:),       INTENT(IN)    :: PRST
REAL, DIMENSION(:),       INTENT(IN)    :: PRGT
REAL, DIMENSION(:),       INTENT(IN)    :: PRHT
REAL, DIMENSION(:),       INTENT(IN)    :: PSIGMA_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PRVHENI_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRHONG_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIMLTC_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSRIMCG_MR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCHONI
REAL, DIMENSION(:),       INTENT(INOUT) :: PRVDEPS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRIAGGS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRIAUTS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRVDEPG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCAUTR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCACCR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRREVAV
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCRIMSS
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCRIMSG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSRIMCG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRACCSS
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRACCSG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSACCRG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRSMLTG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCMLTSR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRICFRRG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRRCFRIG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRICFRR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRWETGH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRWETGH_MR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRGMLTR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRGWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRGDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRDRYHG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRHMLTR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCBERI
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRS_TEND
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRG_TEND
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRH_TEND
REAL, DIMENSION(:),       INTENT(OUT)   :: PSSI
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_TH
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RV
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RR
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RI
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RS
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RG
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RH
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_TH
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RV
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RR
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RI
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RS
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RG
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RH
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_HCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_LCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_HRC
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_LRC
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_HCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_LCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_HRI
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_LRI
REAL, DIMENSION(:,:,:),   INTENT(OUT)   :: PRAINFR   ! Rain fraction
END SUBROUTINE ICE4_TENDENCIES
END INTERFACE
END MODULE MODI_ICE4_TENDENCIES
SUBROUTINE ICE4_TENDENCIES(KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, &
                          &KRR, ODSOFT, PCOMPUTE, &
                          &OWARM, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, &
                          &HSUBG_AUCV_RC, HSUBG_AUCV_RI, HSUBG_PR_PDF, &
                          &PEXN, PRHODREF, PLVFACT, PLSFACT, K1, K2, K3, &
                          &PPRES, PCF, PSIGMA_RC, &
                          &PCIT, &
                          &PT, PTHT, &
                          &PRVT, PRCT, PRRT, PRIT, PRST, PRGT, PRHT, &
                          &PRVHENI_MR, PRRHONG_MR, PRIMLTC_MR, PRSRIMCG_MR, &
                          &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
                          &PRCAUTR, PRCACCR, PRREVAV, &
                          &PRCRIMSS, PRCRIMSG, PRSRIMCG, PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, PRCMLTSR, &
                          &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                          &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                          &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                          &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                          &PRCBERI, &
                          &PRS_TEND, PRG_TEND, PRH_TEND, PSSI, &
                          &PA_TH, PA_RV, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, &
                          &PB_TH, PB_RV, PB_RC, PB_RR, PB_RI, PB_RS, PB_RG, PB_RH, &
                          &PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC, &
                          &PHLI_HCF, PHLI_LCF, PHLI_HRI, PHLI_LRI, PRAINFR)
!!
!!**  PURPOSE
!!    -------
!!      Computes the tendencies
!!
!!    AUTHOR
!!    ------
!!      S. Riette from the splitting of rain_ice source code (nov. 2014)
!!
!!    MODIFICATIONS
!!    -------------
!
!  P. Wautelet 29/05/2019: remove PACK/UNPACK intrinsics (to get more performance and better OpenACC support)
!
!
!*      0. DECLARATIONS
!          ------------
!
USE MODD_CST,            ONLY: XALPI,XBETAI,XCI,XCPV,XEPSILO,XGAMI,XLSTT,XMD,XMV,XP00,XRV,XTT
USE MODD_PARAMETERS,     ONLY: XUNDEF
USE MODD_PARAM_ICE,      ONLY: CSNOWRIMING
USE MODD_RAIN_ICE_DESCR, ONLY: XLBDAS_MAX,XLBEXG,XLBEXH,XLBEXR,XLBEXS,XLBG,XLBH,XLBR,XLBS,XRTMIN
USE MODD_RAIN_ICE_PARAM, ONLY: XSCFAC

#ifdef MNH_OPENACC
USE MODE_MNH_ZWORK,      ONLY: MNH_MEM_GET, MNH_MEM_POSITION_PIN, MNH_MEM_RELEASE
#endif

USE MODI_ICE4_COMPUTE_PDF
USE MODI_ICE4_FAST_RG
USE MODI_ICE4_FAST_RH
USE MODI_ICE4_FAST_RI
USE MODI_ICE4_FAST_RS
USE MODI_ICE4_NUCLEATION
USE MODI_ICE4_RAINFR_VERT
USE MODI_ICE4_RIMLTC
USE MODI_ICE4_RRHONG
USE MODI_ICE4_RSRIMCG_OLD
USE MODI_ICE4_SLOW
USE MODI_ICE4_WARM
!
#ifdef MNH_BITREP
USE MODI_BITREP
#endif
!
USE MODE_MPPDB
!
IMPLICIT NONE
!
!*       0.1   Declarations of dummy arguments :
!
INTEGER,                  INTENT(IN)    :: KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL
INTEGER,                  INTENT(IN)    :: KRR
LOGICAL,                  INTENT(IN)    :: ODSOFT
REAL, DIMENSION(:),       INTENT(IN)    :: PCOMPUTE
LOGICAL,                  INTENT(IN)    :: OWARM
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_RC_RR_ACCR
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_RR_EVAP
CHARACTER(len=4),         INTENT(IN)    :: HSUBG_AUCV_RC
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_AUCV_RI
CHARACTER(len=80),        INTENT(IN)    :: HSUBG_PR_PDF ! pdf for subgrid precipitation
REAL, DIMENSION(:),       INTENT(IN)    :: PEXN
REAL, DIMENSION(:),       INTENT(IN)    :: PRHODREF
REAL, DIMENSION(:),       INTENT(IN)    :: PLVFACT
REAL, DIMENSION(:),       INTENT(IN)    :: PLSFACT
INTEGER, DIMENSION(:),    INTENT(IN)    :: K1
INTEGER, DIMENSION(:),    INTENT(IN)    :: K2
INTEGER, DIMENSION(:),    INTENT(IN)    :: K3
REAL, DIMENSION(:),       INTENT(IN)    :: PPRES
REAL, DIMENSION(:),       INTENT(IN)    :: PCF
REAL, DIMENSION(:),       INTENT(INOUT) :: PCIT
REAL, DIMENSION(:),       INTENT(IN)    :: PT
REAL, DIMENSION(:),       INTENT(IN)    :: PTHT
REAL, DIMENSION(:),       INTENT(IN)    :: PRVT
REAL, DIMENSION(:),       INTENT(IN)    :: PRCT
REAL, DIMENSION(:),       INTENT(IN)    :: PRRT
REAL, DIMENSION(:),       INTENT(IN)    :: PRIT
REAL, DIMENSION(:),       INTENT(IN)    :: PRST
REAL, DIMENSION(:),       INTENT(IN)    :: PRGT
REAL, DIMENSION(:),       INTENT(IN)    :: PRHT
REAL, DIMENSION(:),       INTENT(IN)    :: PSIGMA_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PRVHENI_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRHONG_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIMLTC_MR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSRIMCG_MR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCHONI
REAL, DIMENSION(:),       INTENT(INOUT) :: PRVDEPS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRIAGGS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRIAUTS
REAL, DIMENSION(:),       INTENT(INOUT) :: PRVDEPG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCAUTR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCACCR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRREVAV
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCRIMSS
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCRIMSG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSRIMCG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRACCSS
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRACCSG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSACCRG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRSMLTG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCMLTSR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRICFRRG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRRCFRIG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRICFRR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSWETG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSDRYG
REAL, DIMENSION(:),       INTENT(OUT)   :: PRWETGH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRWETGH_MR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRGMLTR
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRGWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRWETH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRCDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRIDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRSDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRRDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRGDRYH
REAL, DIMENSION(:),       INTENT(OUT)   :: PRDRYHG
REAL, DIMENSION(:),       INTENT(INOUT) :: PRHMLTR
REAL, DIMENSION(:),       INTENT(INOUT) :: PRCBERI
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRS_TEND
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRG_TEND
REAL, DIMENSION(:, :),    INTENT(INOUT) :: PRH_TEND
REAL, DIMENSION(:),       INTENT(OUT)   :: PSSI
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_TH
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RV
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RR
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RI
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RS
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RG
REAL, DIMENSION(:),       INTENT(OUT)   :: PA_RH
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_TH
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RV
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RC
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RR
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RI
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RS
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RG
REAL, DIMENSION(:),       INTENT(OUT)   :: PB_RH
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_HCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_LCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_HRC
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLC_LRC
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_HCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_LCF
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_HRI
REAL, DIMENSION(:),       INTENT(OUT)   :: PHLI_LRI
REAL, DIMENSION(:,:,:),   INTENT(OUT)   :: PRAINFR   ! Rain fraction
!
!*       0.2  declaration of local variables
!
INTEGER                            :: IDX,JI,JJ,JK,JL
INTEGER                            :: ISIZE
LOGICAL, DIMENSION(:), POINTER, CONTIGUOUS :: GLDCOMPUTE
REAL,    DIMENSION(:), POINTER, CONTIGUOUS :: ZWETG ! 1. if graupel growths in wet mode, 0. otherwise
REAL,    DIMENSION(:), POINTER, CONTIGUOUS :: ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, &
                                    & ZT, ZTHT, ZRHT, &
                                    & ZZW, &
                                    & ZKA, ZDV, ZAI, ZCJ, &
                                    & ZRF, &
                                    & ZLBDAR, ZLBDAS, ZLBDAG, ZLBDAH, ZLBDAR_RF, &
                                    & ZRGSI, ZRGSI_MR
REAL, DIMENSION(:,:,:), POINTER, CONTIGUOUS :: ZRRT3D, ZRST3D, ZRGT3D, ZRHT3D
!
!$acc data present(PCOMPUTE,PEXN,PRHODREF,PLVFACT,PLSFACT,K1,K2,K3,PPRES,PCF,PCIT,PT,PTHT,                             &
!$acc&                PRVT,PRCT,PRRT,PRIT,PRST,PRGT,PRHT,PSIGMA_RC,PRVHENI_MR,PRRHONG_MR,PRIMLTC_MR,                   &
!$acc&                PRSRIMCG_MR,PRCHONI,PRVDEPS,PRIAGGS,PRIAUTS,PRVDEPG,PRCAUTR,PRCACCR,PRREVAV,                     &
!$acc&                PRCRIMSS,PRCRIMSG,PRSRIMCG,PRRACCSS,PRRACCSG,PRSACCRG,PRSMLTG,PRCMLTSR,PRICFRRG,PRRCFRIG,        &
!$acc&                PRICFRR,PRCWETG,PRIWETG,PRRWETG,PRSWETG,PRCDRYG,PRIDRYG,PRRDRYG,PRSDRYG,                         &
!$acc&                PRWETGH,PRWETGH_MR,PRGMLTR,PRCWETH,PRIWETH,PRSWETH,PRGWETH,PRRWETH,                              &
!$acc&                PRCDRYH,PRIDRYH,PRSDRYH,PRRDRYH,PRGDRYH,PRDRYHG,PRHMLTR,PRCBERI,PRS_TEND,PRG_TEND,PRH_TEND,PSSI, &
!$acc&                PA_TH,PA_RV,PA_RC,PA_RR,PA_RI,PA_RS,PA_RG,PA_RH,PB_TH,PB_RV,PB_RC,PB_RR,PB_RI,PB_RS,PB_RG,PB_RH, &
!$acc&                PHLC_HCF,PHLC_LCF,PHLC_HRC,PHLC_LRC,PHLI_HCF,PHLI_LCF,PHLI_HRI,PHLI_LRI,PRAINFR, XRTMIN )

IF (MPPDB_INITIALIZED) THEN
  !Check all IN arrays
  CALL MPPDB_CHECK(PCOMPUTE,"ICE4_TENDENCIES beg:PCOMPUTE")
  CALL MPPDB_CHECK(PEXN,"ICE4_TENDENCIES beg:PEXN")
  CALL MPPDB_CHECK(PRHODREF,"ICE4_TENDENCIES beg: PRHODREF:")
  CALL MPPDB_CHECK(PLVFACT,"ICE4_TENDENCIES beg:PLVFACT")
  CALL MPPDB_CHECK(PLSFACT,"ICE4_TENDENCIES beg:PLSFACT")
  CALL MPPDB_CHECK(K1,"ICE4_TENDENCIES beg:K1")
  CALL MPPDB_CHECK(K2,"ICE4_TENDENCIES beg:K2")
  CALL MPPDB_CHECK(K3,"ICE4_TENDENCIES beg:K3")
  CALL MPPDB_CHECK(PPRES,"ICE4_TENDENCIES beg:PPRES")
  CALL MPPDB_CHECK(PCF,"ICE4_TENDENCIES beg:PCF")
  CALL MPPDB_CHECK(PT,"ICE4_TENDENCIES beg:PT")
  CALL MPPDB_CHECK(PTHT,"ICE4_TENDENCIES beg:PTHT")
  CALL MPPDB_CHECK(PRVT,"ICE4_TENDENCIES beg:PRVT")
  CALL MPPDB_CHECK(PRCT,"ICE4_TENDENCIES beg:PRCT")
  CALL MPPDB_CHECK(PRRT,"ICE4_TENDENCIES beg:PRRT")
  CALL MPPDB_CHECK(PRIT,"ICE4_TENDENCIES beg:PRIT")
  CALL MPPDB_CHECK(PRST,"ICE4_TENDENCIES beg:PRST")
  CALL MPPDB_CHECK(PRGT,"ICE4_TENDENCIES beg:PRGT")
  CALL MPPDB_CHECK(PRHT,"ICE4_TENDENCIES beg:PRHT")
  CALL MPPDB_CHECK(PSIGMA_RC,"ICE4_TENDENCIES beg:PSIGMA_RC")
  !Check all INOUT arrays
  CALL MPPDB_CHECK(PCIT,"ICE4_TENDENCIES beg:PCIT")
  CALL MPPDB_CHECK(PRCHONI,"ICE4_TENDENCIES beg:PRCHONI")
  CALL MPPDB_CHECK(PRVDEPS,"ICE4_TENDENCIES beg:PRVDEPS")
  CALL MPPDB_CHECK(PRIAGGS,"ICE4_TENDENCIES beg:PRIAGGS")
  CALL MPPDB_CHECK(PRIAUTS,"ICE4_TENDENCIES beg:PRIAUTS")
  CALL MPPDB_CHECK(PRVDEPG,"ICE4_TENDENCIES beg:PRVDEPG")
  CALL MPPDB_CHECK(PRCAUTR,"ICE4_TENDENCIES beg:PRCAUTR")
  CALL MPPDB_CHECK(PRCACCR,"ICE4_TENDENCIES beg:PRCACCR")
  CALL MPPDB_CHECK(PRREVAV,"ICE4_TENDENCIES beg:PRREVAV")
  CALL MPPDB_CHECK(PRSMLTG,"ICE4_TENDENCIES beg:PRSMLTG")
  CALL MPPDB_CHECK(PRCMLTSR,"ICE4_TENDENCIES beg:PRCMLTSR")
  CALL MPPDB_CHECK(PRICFRRG,"ICE4_TENDENCIES beg:PRICFRRG")
  CALL MPPDB_CHECK(PRRCFRIG,"ICE4_TENDENCIES beg:PRRCFRIG")
  CALL MPPDB_CHECK(PRICFRR,"ICE4_TENDENCIES beg:PRICFRR")
  CALL MPPDB_CHECK(PRGMLTR,"ICE4_TENDENCIES beg:PRGMLTR")
  CALL MPPDB_CHECK(PRHMLTR,"ICE4_TENDENCIES beg:PRHMLTR")
  CALL MPPDB_CHECK(PRCBERI,"ICE4_TENDENCIES beg:PRCBERI")
  CALL MPPDB_CHECK(PRS_TEND,"ICE4_TENDENCIES beg:PRS_TEND")
  CALL MPPDB_CHECK(PRG_TEND,"ICE4_TENDENCIES beg:PRG_TEND")
  CALL MPPDB_CHECK(PRH_TEND,"ICE4_TENDENCIES beg:PRH_TEND")
END IF

isize = size( pcompute )

#ifndef MNH_OPENACC
allocate( gldcompute(isize ) )
allocate( zwetg    (isize ) )
allocate( zrvt     (isize ) )
allocate( zrct     (isize ) )
allocate( zrrt     (isize ) )
allocate( zrit     (isize ) )
allocate( zrst     (isize ) )
allocate( zrgt     (isize ) )
allocate( zt       (isize ) )
allocate( ztht     (isize ) )
allocate( zrht     (isize ) )
allocate( zzw      (isize ) )
allocate( zka      (isize ) )
allocate( zdv      (isize ) )
allocate( zai      (isize ) )
allocate( zcj      (isize ) )
allocate( zrf      (isize ) )
allocate( zlbdar   (isize ) )
allocate( zlbdas   (isize ) )
allocate( zlbdag   (isize ) )
allocate( zlbdah   (isize ) )
allocate( zlbdar_rf(isize ) )
allocate( zrgsi    (isize ) )
allocate( zrgsi_mr (isize ) )

allocate( zrrt3d(kit, kjt, kkt ) )
allocate( zrst3d(kit, kjt, kkt ) )
allocate( zrgt3d(kit, kjt, kkt ) )
allocate( zrht3d(kit, kjt, kkt ) )
#else
!Pin positions in the pools of MNH memory
CALL MNH_MEM_POSITION_PIN()

allocate( gldcompute(isize ) )

CALL MNH_MEM_GET( zwetg, isize )
CALL MNH_MEM_GET( zrvt, isize )
CALL MNH_MEM_GET( zrct, isize )
CALL MNH_MEM_GET( zrrt, isize )
CALL MNH_MEM_GET( zrit, isize )
CALL MNH_MEM_GET( zrst, isize )
CALL MNH_MEM_GET( zrgt, isize )
CALL MNH_MEM_GET( zt,   isize )
CALL MNH_MEM_GET( ztht, isize )
CALL MNH_MEM_GET( zrht, isize )
CALL MNH_MEM_GET( zzw, isize )
CALL MNH_MEM_GET( zka, isize )
CALL MNH_MEM_GET( zdv, isize )
CALL MNH_MEM_GET( zai, isize )
CALL MNH_MEM_GET( zcj, isize )
CALL MNH_MEM_GET( zrf, isize )
CALL MNH_MEM_GET( zlbdar, isize )
CALL MNH_MEM_GET( zlbdas, isize )
CALL MNH_MEM_GET( zlbdag, isize )
CALL MNH_MEM_GET( zlbdah, isize )
CALL MNH_MEM_GET( zlbdar_rf, isize )
CALL MNH_MEM_GET( zrgsi,     isize )
CALL MNH_MEM_GET( zrgsi_mr,  isize )

CALL MNH_MEM_GET( zrrt3d, kit, kjt, kkt )
CALL MNH_MEM_GET( zrst3d, kit, kjt, kkt )
CALL MNH_MEM_GET( zrgt3d, kit, kjt, kkt )
CALL MNH_MEM_GET( zrht3d, kit, kjt, kkt )
#endif

!$acc data create( GLDCOMPUTE )  &
!$acc&     present( ZWETG,ZRVT,ZRCT,ZRRT,ZRIT,ZRST,ZRGT,ZT,ZTHT,ZRHT,ZZW,ZKA,ZDV,ZAI,ZCJ, &
!$acc&              ZRF,ZLBDAR,ZLBDAS,ZLBDAG,ZLBDAH,ZLBDAR_RF,ZRGSI,ZRGSI_MR,  &
!$acc&              ZRRT3D,ZRST3D,ZRGT3D,ZRHT3D )

!$acc kernels
PA_TH(:)=0.
PA_RV(:)=0.
PA_RC(:)=0.
PA_RR(:)=0.
PA_RI(:)=0.
PA_RS(:)=0.
PA_RG(:)=0.
PA_RH(:)=0.
PB_TH(:)=0.
PB_RV(:)=0.
PB_RC(:)=0.
PB_RR(:)=0.
PB_RI(:)=0.
PB_RS(:)=0.
PB_RG(:)=0.
PB_RH(:)=0.
!
!$acc loop independent
DO CONCURRENT ( JL = 1 : ISIZE )
  ZRVT(JL)=PRVT(JL)
  ZRCT(JL)=PRCT(JL)
  ZRRT(JL)=PRRT(JL)
  ZRIT(JL)=PRIT(JL)
  ZRST(JL)=PRST(JL)
  ZRGT(JL)=PRGT(JL)
  ZTHT(JL)=PTHT(JL)
  ZRHT(JL)=PRHT(JL)
  ZT(JL)=PT(JL)
ENDDO
!$acc end kernels
IF(ODSOFT) THEN
!$acc kernels
  PRVHENI_MR(:)=0.
  PRRHONG_MR(:)=0.
  PRIMLTC_MR(:)=0.
  PRSRIMCG_MR(:)=0.
!$acc end kernels
ELSE
  !
  !*       2.     COMPUTES THE SLOW COLD PROCESS SOURCES
  !               --------------------------------------
!$acc kernels
  GLDCOMPUTE = PCOMPUTE==1.
!$acc end kernels

  CALL ICE4_NUCLEATION(ODSOFT, GLDCOMPUTE, &
                       ZTHT, PPRES, PRHODREF, PEXN, PLSFACT, ZT, &
                       ZRVT, &
                       PCIT, PRVHENI_MR, PB_TH, PB_RV, PB_RI)
!$acc kernels
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    ZRIT(JL)=ZRIT(JL) + PRVHENI_MR(JL)
    ZRVT(JL)=ZRVT(JL) - PRVHENI_MR(JL)
    ZTHT(JL)=ZTHT(JL) + PRVHENI_MR(JL)*PLSFACT(JL)
    ZT(JL) = ZTHT(JL) * PEXN(JL)
  ENDDO
!$acc end kernels
  !
  !*       3.3     compute the spontaneous freezing source: RRHONG
  !
  CALL ICE4_RRHONG(ODSOFT, PCOMPUTE, &
                  &PEXN, PLVFACT, PLSFACT, &
                  &ZT,   ZRRT, &
                  &ZTHT, &
                  &PRRHONG_MR, PB_TH, PB_RR, PB_RG)
!$acc kernels
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    ZRGT(JL) = ZRGT(JL) + PRRHONG_MR(JL)
    ZRRT(JL) = ZRRT(JL) - PRRHONG_MR(JL)
    ZTHT(JL) = ZTHT(JL) + PRRHONG_MR(JL)*(PLSFACT(JL)-PLVFACT(JL)) ! f(L_f*(RRHONG))
    ZT(JL) = ZTHT(JL) * PEXN(JL)
  ENDDO
!$acc end kernels
  !
  !*       7.1    cloud ice melting
  !
  CALL ICE4_RIMLTC(ODSOFT, PCOMPUTE, &
                  &PEXN, PLVFACT, PLSFACT, &
                  &ZT, &
                  &ZTHT, ZRIT, &
                  &PRIMLTC_MR, PB_TH, PB_RC, PB_RI)
!$acc kernels
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    ZRCT(JL) = ZRCT(JL) + PRIMLTC_MR(JL)
    ZRIT(JL) = ZRIT(JL) - PRIMLTC_MR(JL)
    ZTHT(JL) = ZTHT(JL) - PRIMLTC_MR(JL)*(PLSFACT(JL)-PLVFACT(JL)) ! f(L_f*(-RIMLTC))
    ZT(JL) = ZTHT(JL) * PEXN(JL)
  ENDDO
!$acc end kernels
  !
  !        5.1.6  riming-conversion of the large sized aggregates into graupel (old parametrisation)
  !
  IF(CSNOWRIMING=='OLD ') THEN
!$acc kernels
!$acc loop independent
    DO CONCURRENT ( JL = 1 : ISIZE )
      IF ( ZRST(JL) > 0. ) THEN
#ifndef MNH_BITREP
        ZLBDAS(JL)  = MIN(XLBDAS_MAX, XLBS*(PRHODREF(JL)*MAX(ZRST(JL), XRTMIN(5)))**XLBEXS)
#else
        ZLBDAS(JL)  = MIN(XLBDAS_MAX, XLBS*BR_POW(PRHODREF(JL)*MAX(ZRST(JL), XRTMIN(5)),XLBEXS))
#endif
      ELSE
        ZLBDAS(JL) = 0.
      END IF
    END DO
!$acc end kernels
    CALL ICE4_RSRIMCG_OLD(ODSOFT, PCOMPUTE==1., &
                         &PRHODREF, &
                         &ZLBDAS, &
                         &ZT, ZRCT, ZRST, &
                         &PRSRIMCG_MR, PB_RS, PB_RG)
!$acc kernels
!$acc loop independent
    DO CONCURRENT ( JL = 1 : ISIZE )
      ZRST(JL) = ZRST(JL) - PRSRIMCG_MR(JL)
      ZRGT(JL) = ZRGT(JL) + PRSRIMCG_MR(JL)
    ENDDO
!$acc end kernels
  ELSE
!$acc kernels
    PRSRIMCG_MR(:) = 0.
!$acc end kernels
  ENDIF
ENDIF
!
!* Derived fields
!
IF(ISIZE>0) THEN
  IF(.NOT. ODSOFT) THEN
!$acc kernels
!$acc loop independent
  DO JL = 1, ISIZE
#ifndef MNH_BITREP
    ZZW(JL) = EXP(XALPI-XBETAI/ZT(JL)-XGAMI*ALOG(ZT(JL)))
#else
    ZZW(JL) = BR_EXP(XALPI-XBETAI/ZT(JL)-XGAMI*BR_LOG(ZT(JL)))
#endif

    PSSI(JL) = ZRVT(JL)*( PPRES(JL)-ZZW(JL) ) / ( XEPSILO * ZZW(JL) ) - 1.0
                                                      ! Supersaturation over ice
    ZKA(JL) = 2.38E-2 + 0.0071E-2*(ZT(JL)-XTT) ! k_a
#ifndef MNH_BITREP
    ZDV(JL) = 0.211E-4*(ZT(JL)/XTT)**1.94 * (XP00/PPRES(JL)) ! D_v
    ZAI(JL) = (XLSTT+(XCPV-XCI)*(ZT(JL)-XTT))**2 / (ZKA(JL)*XRV*ZT(JL)**2) &
                                 + ( XRV*ZT(JL) ) / (ZDV(JL)*ZZW(JL))
    ZCJ(JL) = XSCFAC*PRHODREF(JL)**0.3 / SQRT(1.718E-5+0.0049E-5*(ZT(JL)-XTT))
#else
    ZDV(JL) = 0.211E-4*BR_POW(ZT(JL)/XTT,1.94) * (XP00/PPRES(JL)) ! D_v
    ZAI(JL) = BR_P2(XLSTT+(XCPV-XCI)*(ZT(JL)-XTT)) / (ZKA(JL)*XRV*BR_P2(ZT(JL))) &
                                 + ( XRV*ZT(JL) ) / (ZDV(JL)*ZZW(JL))
    ZCJ(JL) = XSCFAC*BR_POW(PRHODREF(JL),0.3) / SQRT(1.718E-5+0.0049E-5*(ZT(JL)-XTT))
#endif
  ENDDO
!$acc end kernels
  ELSE
!$acc kernels
    PSSI(:) = 0. !PSSI is an OUT variable. It must be set in this subroutine.
!$acc end kernels
    IF ( MPPDB_INITIALIZED ) THEN
      !Variables not used but necessary for comparisons with MPPDB_CHECK
!$acc kernels
      ZKA(:) = XUNDEF
      ZDV(:) = XUNDEF
      ZAI(:) = XUNDEF
      ZCJ(:) = XUNDEF
!$acc end kernels
    END IF
  ENDIF
  !
  !Cloud water split between high and low content part is done here
  CALL ICE4_COMPUTE_PDF(HSUBG_AUCV_RC, HSUBG_AUCV_RI, HSUBG_PR_PDF,&
                        PRHODREF, ZRCT, ZRIT, PCF, ZT, PSIGMA_RC,&
                        PHLC_HCF, PHLC_LCF, PHLC_HRC, PHLC_LRC,&
                        PHLI_HCF, PHLI_LCF, PHLI_HRI, PHLI_LRI, ZRF)
  IF(HSUBG_RC_RR_ACCR=='PRFR' .OR. HSUBG_RR_EVAP=='PRFR') THEN
    !Diagnostic of precipitation fraction
!$acc kernels
    PRAINFR(:,:,:) = 0.
    ZRRT3D (:,:,:) = 0.
    ZRST3D (:,:,:) = 0.
    ZRGT3D (:,:,:) = 0.
    ZRHT3D (:,:,:) = 0.
!$acc loop independent
    DO JL=1,ISIZE
      PRAINFR(K1(JL), K2(JL), K3(JL)) = ZRF(JL)
      ZRRT3D (K1(JL), K2(JL), K3(JL)) = ZRRT(JL)
      ZRST3D (K1(JL), K2(JL), K3(JL)) = ZRST(JL)
      ZRGT3D (K1(JL), K2(JL), K3(JL)) = ZRGT(JL)
    END DO
!$acc end kernels
    IF (KRR==7) THEN
!$acc kernels
!$acc loop independent
      DO JL=1,ISIZE
        ZRHT3D (K1(JL), K2(JL), K3(JL)) = ZRHT(JL)
      ENDDO
!$acc end kernels
      CALL ICE4_RAINFR_VERT(KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, PRAINFR(:,:,:), &
                         &ZRRT3D(:,:,:), ZRST3D(:,:,:), ZRGT3D(:,:,:), ZRHT3D(:,:,:))
    ELSE
      CALL ICE4_RAINFR_VERT(KIB, KIE, KIT, KJB, KJE, KJT, KKB, KKE, KKT, KKL, PRAINFR(:,:,:), &
                         &ZRRT3D(:,:,:), ZRST3D(:,:,:), ZRGT3D(:,:,:))
    ENDIF
!$acc kernels
!$acc loop independent
    DO JL=1,ISIZE
      ZRF(JL)=PRAINFR(K1(JL), K2(JL), K3(JL))
    END DO
!$acc end kernels
  ELSE
!$acc kernels
    PRAINFR(:,:,:)=1.
    ZRF(:)=1.
!$acc end kernels
  ENDIF
  !
  !*  compute the slope parameters
  !
!$acc kernels
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    IF ( ZRST(JL) > 0. ) THEN
#ifndef MNH_BITREP
      ZLBDAS(JL)  = MIN(XLBDAS_MAX, XLBS*(PRHODREF(JL)*MAX(ZRST(JL), XRTMIN(5)))**XLBEXS)
#else
      ZLBDAS(JL)  = MIN(XLBDAS_MAX, XLBS*BR_POW(PRHODREF(JL)*MAX(ZRST(JL), XRTMIN(5)),XLBEXS))
#endif
    ELSE
      ZLBDAS(JL) = 0.
    END IF
  END DO
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    IF ( ZRGT(JL) > 0. ) THEN
#ifndef MNH_BITREP
      ZLBDAG(JL)  = XLBG*(PRHODREF(JL)*MAX(ZRGT(JL), XRTMIN(6)))**XLBEXG
#else
      ZLBDAG(JL)  = XLBG*BR_POW(PRHODREF(JL)*MAX(ZRGT(JL), XRTMIN(6)),XLBEXG)
#endif
    ELSE
      ZLBDAG(JL) = 0.
    END IF
  END DO
  !ZLBDAR will be used when we consider rain diluted over the grid box
!$acc loop independent
  DO CONCURRENT ( JL = 1 : ISIZE )
    IF ( ZRRT(JL) > 0. ) THEN
#ifndef MNH_BITREP
      ZLBDAR(JL)  = XLBR*( PRHODREF(JL)*MAX( ZRRT(JL), XRTMIN(3)))**XLBEXR
#else
      ZLBDAR(JL)  = XLBR*BR_POW(PRHODREF(JL)*MAX( ZRRT(JL), XRTMIN(3)),XLBEXR)
#endif
    ELSE
      ZLBDAR(JL) = 0.
    END IF
  END DO
!$acc end kernels
  !ZLBDAR_RF is used when we consider rain concentrated in its fraction
  IF (HSUBG_RC_RR_ACCR=='PRFR' .OR. HSUBG_RR_EVAP=='PRFR') THEN
!PW: 20211012: kernels directive inside IF to prevent crash with nvhpc 21.9
!$acc kernels
!$acc loop independent
    DO CONCURRENT( JL = 1 : ISIZE )
      IF ( ZRRT(JL) >0. .AND. ZRF(JL) > 0. ) THEN
#ifndef MNH_BITREP
        ZLBDAR_RF(JL) = XLBR*( PRHODREF(JL) *MAX( ZRRT(JL)/ZRF(JL) , XRTMIN(3)))**XLBEXR
#else
        ZLBDAR_RF(JL) = XLBR*BR_POW(PRHODREF(JL) *MAX( ZRRT(JL)/ZRF(JL) , XRTMIN(3)),XLBEXR)
#endif
      ELSE
        ZLBDAR_RF(JL) = 0.
      END IF
    END DO
!$acc end kernels
  ELSE
!$acc kernels
!     ZLBDAR_RF(:) = ZLBDAR(:)
!$acc loop independent
    DO CONCURRENT( JL = 1 : ISIZE )
      ZLBDAR_RF(JL) = ZLBDAR(JL)
    END DO
!$acc end kernels
  ENDIF
!$acc kernels
  IF(KRR==7) THEN
!$acc loop independent
    DO CONCURRENT ( JL = 1 : ISIZE )
      IF ( PRHT(JL) > 0. ) THEN
#ifndef MNH_BITREP
        ZLBDAH(JL) = XLBH*(PRHODREF(JL)*MAX(PRHT(JL), XRTMIN(7)))**XLBEXH
#else
        ZLBDAH(JL) = XLBH*BR_POW(PRHODREF(JL)*MAX(PRHT(JL), XRTMIN(7)),XLBEXH)
#endif
      ELSE
        ZLBDAH(JL) = 0.
      END IF
    END DO
  ENDIF
!$acc end kernels
ENDIF
!
!
CALL ICE4_SLOW(ODSOFT, PCOMPUTE, PRHODREF, ZT, &
              &PSSI, PLVFACT, PLSFACT, &
              &ZRVT, ZRCT, ZRIT, ZRST, ZRGT, &
              &ZLBDAS, ZLBDAG, &
              &ZAI, ZCJ, PHLI_HCF, PHLI_HRI, &
              &PRCHONI, PRVDEPS, PRIAGGS, PRIAUTS, PRVDEPG, &
              &PA_TH, PA_RV, PA_RC, PA_RI, PA_RS, PA_RG)
!
!-------------------------------------------------------------------------------
!
!
!*       3.     COMPUTES THE SLOW WARM PROCESS SOURCES
!               --------------------------------------
!
!
IF(OWARM) THEN    !  Check if the formation of the raindrops by the slow
                  !  warm processes is allowed
  CALL ICE4_WARM(ODSOFT, PCOMPUTE, HSUBG_RC_RR_ACCR, HSUBG_RR_EVAP, &
                &PRHODREF, PLVFACT, ZT, PPRES, ZTHT,&
                &ZLBDAR, ZLBDAR_RF, ZKA, ZDV, ZCJ, &
                &PHLC_LCF, PHLC_HCF, PHLC_LRC, PHLC_HRC, &
                &PCF, ZRF, &
                &ZRVT, ZRCT, ZRRT, &
                &PRCAUTR, PRCACCR, PRREVAV, &
                &PA_TH, PA_RV, PA_RC, PA_RR)
ELSE
!$acc kernels
  PRCAUTR(:)=0.
  PRCACCR(:)=0.
  PRREVAV(:)=0.
!$acc end kernels
END IF
!
!-------------------------------------------------------------------------------
!
!
!*       4.     COMPUTES THE FAST COLD PROCESS SOURCES FOR r_s
!               ----------------------------------------------
!
CALL ICE4_FAST_RS(ODSOFT, PCOMPUTE, &
                 &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                 &ZDV, ZKA, ZCJ, &
                 &ZLBDAR, ZLBDAS, &
                 &ZT, ZRVT, ZRCT, ZRRT, ZRST, &
                 &PRIAGGS, &
                 &PRCRIMSS, PRCRIMSG, PRSRIMCG, &
                 &PRRACCSS, PRRACCSG, PRSACCRG, PRSMLTG, &
                 &PRCMLTSR, &
                 &PRS_TEND, &
                 &PA_TH, PA_RC, PA_RR, PA_RS, PA_RG)
!
!-------------------------------------------------------------------------------
!
!
!*       5.        COMPUTES THE FAST COLD PROCESS SOURCES FOR r_g
!                  ------------------------------------------------------
!
!$acc kernels
!$acc loop independent
DO CONCURRENT ( JL = 1 : ISIZE )
  ZRGSI(JL) = PRVDEPG(JL) + PRSMLTG(JL) + PRRACCSG(JL) + &
           & PRSACCRG(JL) + PRCRIMSG(JL) + PRSRIMCG(JL)
  ZRGSI_MR(JL) = PRRHONG_MR(JL) + PRSRIMCG_MR(JL)
ENDDO
!$acc end kernels
CALL ICE4_FAST_RG(ODSOFT, PCOMPUTE, KRR, &
                 &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                 &ZDV, ZKA, ZCJ, PCIT, &
                 &ZLBDAR, ZLBDAS, ZLBDAG, &
                 &ZT, ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, &
                 &ZRGSI, ZRGSI_MR(:), &
                 &ZWETG, &
                 &PRICFRRG, PRRCFRIG, PRICFRR, PRCWETG, PRIWETG, PRRWETG, PRSWETG, &
                 &PRCDRYG, PRIDRYG, PRRDRYG, PRSDRYG, PRWETGH, PRWETGH_MR, PRGMLTR, &
                 &PRG_TEND, &
                 &PA_TH, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH, PB_RG, PB_RH)
!
!-------------------------------------------------------------------------------
!
!
!*       6.     COMPUTES THE FAST COLD PROCESS SOURCES FOR r_h
!               ----------------------------------------------
!
IF (KRR==7) THEN
  CALL ICE4_FAST_RH(ODSOFT, PCOMPUTE, ZWETG, &
                   &PRHODREF, PLVFACT, PLSFACT, PPRES, &
                   &ZDV, ZKA, ZCJ, &
                   &ZLBDAS, ZLBDAG, ZLBDAR, ZLBDAH, &
                   &ZT,  ZRVT, ZRCT, ZRRT, ZRIT, ZRST, ZRGT, PRHT, &
                   &PRCWETH, PRIWETH, PRSWETH, PRGWETH, PRRWETH, &
                   &PRCDRYH, PRIDRYH, PRSDRYH, PRRDRYH, PRGDRYH, PRDRYHG, PRHMLTR, &
                   &PRH_TEND, &
                   &PA_TH, PA_RC, PA_RR, PA_RI, PA_RS, PA_RG, PA_RH)
ELSE
!$acc kernels
  PRCWETH(:)=0.
  PRIWETH(:)=0.
  PRSWETH(:)=0.
  PRGWETH(:)=0.
  PRRWETH(:)=0.
  PRCDRYH(:)=0.
  PRIDRYH(:)=0.
  PRSDRYH(:)=0.
  PRRDRYH(:)=0.
  PRGDRYH(:)=0.
  PRDRYHG(:)=0.
  PRHMLTR(:)=0.
!$acc end kernels
END IF
!
!-------------------------------------------------------------------------------
!
!
!*       7.     COMPUTES SPECIFIC SOURCES OF THE WARM AND COLD CLOUDY SPECIES
!               -------------------------------------------------------------
!
CALL ICE4_FAST_RI(ODSOFT, PCOMPUTE, &
                 &PRHODREF, PLVFACT, PLSFACT, &
                 &ZAI, ZCJ, PCIT, &
                 &PSSI, &
                 &ZRCT, ZRIT, &
                 &PRCBERI, PA_TH, PA_RC, PA_RI)
!
!
IF (MPPDB_INITIALIZED) THEN
  !Check all INOUT arrays
  CALL MPPDB_CHECK(PCIT,"ICE4_TENDENCIES end:PCIT")
  CALL MPPDB_CHECK(PRCHONI,"ICE4_TENDENCIES end:PRCHONI")
  CALL MPPDB_CHECK(PRVDEPS,"ICE4_TENDENCIES end:PRVDEPS")
  CALL MPPDB_CHECK(PRIAGGS,"ICE4_TENDENCIES end:PRIAGGS")
  CALL MPPDB_CHECK(PRIAUTS,"ICE4_TENDENCIES end:PRIAUTS")
  CALL MPPDB_CHECK(PRVDEPG,"ICE4_TENDENCIES end:PRVDEPG")
  CALL MPPDB_CHECK(PRCAUTR,"ICE4_TENDENCIES end:PRCAUTR")
  CALL MPPDB_CHECK(PRCACCR,"ICE4_TENDENCIES end:PRCACCR")
  CALL MPPDB_CHECK(PRREVAV,"ICE4_TENDENCIES end:PRREVAV")
  CALL MPPDB_CHECK(PRSMLTG,"ICE4_TENDENCIES end:PRSMLTG")
  CALL MPPDB_CHECK(PRCMLTSR,"ICE4_TENDENCIES end:PRCMLTSR")
  CALL MPPDB_CHECK(PRICFRRG,"ICE4_TENDENCIES end:PRICFRRG")
  CALL MPPDB_CHECK(PRRCFRIG,"ICE4_TENDENCIES end:PRRCFRIG")
  CALL MPPDB_CHECK(PRICFRR,"ICE4_TENDENCIES end:PRICFRR")
  CALL MPPDB_CHECK(PRGMLTR,"ICE4_TENDENCIES end:PRGMLTR")
  CALL MPPDB_CHECK(PRHMLTR,"ICE4_TENDENCIES end:PRHMLTR")
  CALL MPPDB_CHECK(PRCBERI,"ICE4_TENDENCIES end:PRCBERI")
  CALL MPPDB_CHECK(PRS_TEND,"ICE4_TENDENCIES end:PRS_TEND")
  CALL MPPDB_CHECK(PRG_TEND,"ICE4_TENDENCIES end:PRG_TEND")
  CALL MPPDB_CHECK(PRH_TEND,"ICE4_TENDENCIES end:PRH_TEND")
  !Check all OUT arrays
  CALL MPPDB_CHECK(PRCRIMSS,"ICE4_TENDENCIES end:PRCRIMSS")
  CALL MPPDB_CHECK(PRCRIMSG,"ICE4_TENDENCIES end:PRCRIMSG")
  CALL MPPDB_CHECK(PRSRIMCG,"ICE4_TENDENCIES end:PRSRIMCG")
  CALL MPPDB_CHECK(PRRACCSS,"ICE4_TENDENCIES end:PRRACCSS")
  CALL MPPDB_CHECK(PRRACCSG,"ICE4_TENDENCIES end:PRRACCSG")
  CALL MPPDB_CHECK(PRSACCRG,"ICE4_TENDENCIES end:PRSACCRG")
  CALL MPPDB_CHECK(PRVHENI_MR,"ICE4_TENDENCIES end:PRVHENI_MR")
  CALL MPPDB_CHECK(PRRHONG_MR,"ICE4_TENDENCIES end:PRRHONG_MR")
  CALL MPPDB_CHECK(PRIMLTC_MR,"ICE4_TENDENCIES end:PRIMLTC_MR")
  CALL MPPDB_CHECK(PRSRIMCG_MR,"ICE4_TENDENCIES end:PRSRIMCG_MR")
  CALL MPPDB_CHECK(PRCWETG,"ICE4_TENDENCIES end:PRCWETG")
  CALL MPPDB_CHECK(PRIWETG,"ICE4_TENDENCIES end:PRIWETG")
  CALL MPPDB_CHECK(PRRWETG,"ICE4_TENDENCIES end:PRRWETG")
  CALL MPPDB_CHECK(PRSWETG,"ICE4_TENDENCIES end:PRSWETG")
  CALL MPPDB_CHECK(PRCDRYG,"ICE4_TENDENCIES end:PRCDRYG")
  CALL MPPDB_CHECK(PRIDRYG,"ICE4_TENDENCIES end:PRIDRYG")
  CALL MPPDB_CHECK(PRRDRYG,"ICE4_TENDENCIES end:PRRDRYG")
  CALL MPPDB_CHECK(PRSDRYG,"ICE4_TENDENCIES end:PRSDRYG")
  CALL MPPDB_CHECK(PRWETGH,"ICE4_TENDENCIES end:PRWETGH")
  CALL MPPDB_CHECK(PRWETGH_MR,"ICE4_TENDENCIES end:PRWETGH_MR")
  CALL MPPDB_CHECK(PRCWETH,"ICE4_TENDENCIES end:PRCWETH")
  CALL MPPDB_CHECK(PRIWETH,"ICE4_TENDENCIES end:PRIWETH")
  CALL MPPDB_CHECK(PRSWETH,"ICE4_TENDENCIES end:PRSWETH")
  CALL MPPDB_CHECK(PRGWETH,"ICE4_TENDENCIES end:PRGWETH")
  CALL MPPDB_CHECK(PRRWETH,"ICE4_TENDENCIES end:PRRWETH")
  CALL MPPDB_CHECK(PRCDRYH,"ICE4_TENDENCIES end:PRCDRYH")
  CALL MPPDB_CHECK(PRIDRYH,"ICE4_TENDENCIES end:PRIDRYH")
  CALL MPPDB_CHECK(PRSDRYH,"ICE4_TENDENCIES end:PRSDRYH")
  CALL MPPDB_CHECK(PRRDRYH,"ICE4_TENDENCIES end:PRRDRYH")
  CALL MPPDB_CHECK(PRGDRYH,"ICE4_TENDENCIES end:PRGDRYH")
  CALL MPPDB_CHECK(PRDRYHG,"ICE4_TENDENCIES end:PRDRYHG")
  CALL MPPDB_CHECK(PSSI,"ICE4_TENDENCIES end:PSSI")
  CALL MPPDB_CHECK(PA_TH,"ICE4_TENDENCIES end:PA_TH")
  CALL MPPDB_CHECK(PA_RV,"ICE4_TENDENCIES end:PA_RV")
  CALL MPPDB_CHECK(PA_RC,"ICE4_TENDENCIES end:PA_RC")
  CALL MPPDB_CHECK(PA_RR,"ICE4_TENDENCIES end:PA_RR")
  CALL MPPDB_CHECK(PA_RI,"ICE4_TENDENCIES end:PA_RI")
  CALL MPPDB_CHECK(PA_RS,"ICE4_TENDENCIES end:PA_RS")
  CALL MPPDB_CHECK(PA_RG,"ICE4_TENDENCIES end:PA_RG")
  CALL MPPDB_CHECK(PA_RH,"ICE4_TENDENCIES end:PA_RH")
  CALL MPPDB_CHECK(PB_TH,"ICE4_TENDENCIES end:PB_TH")
  CALL MPPDB_CHECK(PB_RV,"ICE4_TENDENCIES end:PB_RV")
  CALL MPPDB_CHECK(PB_RC,"ICE4_TENDENCIES end:PB_RC")
  CALL MPPDB_CHECK(PB_RR,"ICE4_TENDENCIES end:PB_RR")
  CALL MPPDB_CHECK(PB_RI,"ICE4_TENDENCIES end:PB_RI")
  CALL MPPDB_CHECK(PB_RS,"ICE4_TENDENCIES end:PB_RS")
  CALL MPPDB_CHECK(PB_RG,"ICE4_TENDENCIES end:PB_RG")
  CALL MPPDB_CHECK(PB_RH,"ICE4_TENDENCIES end:PB_RH")
  CALL MPPDB_CHECK(PHLC_HCF,"ICE4_TENDENCIES end:PHLC_HCF")
  CALL MPPDB_CHECK(PHLC_LCF,"ICE4_TENDENCIES end:PHLC_LCF")
  CALL MPPDB_CHECK(PHLC_HRC,"ICE4_TENDENCIES end:PHLC_HRC")
  CALL MPPDB_CHECK(PHLC_LRC,"ICE4_TENDENCIES end:PHLC_LRC")
  CALL MPPDB_CHECK(PHLI_HCF,"ICE4_TENDENCIES end:PHLI_HCF")
  CALL MPPDB_CHECK(PHLI_LCF,"ICE4_TENDENCIES end:PHLI_LCF")
  CALL MPPDB_CHECK(PHLI_HRI,"ICE4_TENDENCIES end:PHLI_HRI")
  CALL MPPDB_CHECK(PHLI_LRI,"ICE4_TENDENCIES end:PHLI_LRI")
  CALL MPPDB_CHECK(PRAINFR,"ICE4_TENDENCIES end:PRAINFR")
END IF

!$acc end data

#ifndef MNH_OPENACC
deallocate( zrht3d )
deallocate( zrgt3d )
deallocate( zrst3d )
deallocate( zrrt3d )
deallocate( zrgsi_mr )
deallocate( zrgsi    )
deallocate( zlbdar_rf)
deallocate( zlbdah   )
deallocate( zlbdag   )
deallocate( zlbdas   )
deallocate( zlbdar   )
deallocate( zrf      )
deallocate( zcj      )
deallocate( zai      )
deallocate( zdv      )
deallocate( zka      )
deallocate( zzw      )
deallocate( zrht     )
deallocate( ztht     )
deallocate( zt       )
deallocate( zrgt     )
deallocate( zrst     )
deallocate( zrit     )
deallocate( zrrt     )
deallocate( zrct     )
deallocate( zrvt     )
deallocate( zwetg    )
deallocate( gldcompute )
#else
!Release all memory allocated with MNH_MEM_GET calls since last call to MNH_MEM_POSITION_PIN
CALL MNH_MEM_RELEASE()

deallocate( gldcompute )
#endif

!$acc end data

END SUBROUTINE ICE4_TENDENCIES
